import React from 'react';
import PropTypes from 'prop-types';
import classNames from 'classnames';
import styles from './Button.scss';

const Button = ({ children, className, type, ...props }) => {
  return (
    <button
      className={classNames(className, styles[type], styles.btn)}
      {...props}
    >
      {children}
    </button>
  );
};
  
Button.propTypes = {
  children: PropTypes.node,
  className: PropTypes.string,
  type: PropTypes.string
};

export default Button;