import React from 'react';
import PropTypes from 'prop-types';
import classNames from 'classnames';
import styles from './Link.scss';

const Link = ({ children, className, ...props }) => {
  return (
    <a
      className={classNames(className, styles.link)}
      {...props}
    >
      {children}
    </a>
  );
};
  
Link.propTypes = {
  children: PropTypes.node,
  className: PropTypes.string,
};

export default Link;