import React from 'react';
import PropTypes from 'prop-types';
import classNames from 'classnames';
import styles from './Tile.scss';

const Tile = ({ title, color, children, className, ...props }) => {
  return (
    <div className={classNames(styles.container, className)} style={{backgroundColor: color}} {...props}>
      <figure className={styles.figure}>
        {children}
      </figure>
      <h3 className={styles.title}>{title}</h3>
    </div>
  );
};
  
Tile.propTypes = {
  title: PropTypes.string,
  color: PropTypes.string,
  className: PropTypes.string,
  children: PropTypes.node,
};

export default Tile;