import React from 'react';
import PropTypes from 'prop-types';
import classNames from 'classnames';
import styles from './Title.scss';

const Title = ({ children, className, level, ...props }) => {
  const Tag = `h${level}`
  return (
    <Tag
      className={classNames(className, styles.title)}
      {...props}
    >
      {children}
    </Tag>
  );
};
  
Title.propTypes = {
  children: PropTypes.node,
  className: PropTypes.string,
  level: PropTypes.oneOf([1, 2, 3, 4, 5]),
};

Title.defaultProps = {
  level: 2,
}

export default Title;